#include <windows.h>
#include <stdlib.h>
 
typedef struct tagWaitListElement
{
	struct tagWaitListElement *pNext;
	long *pRetCode;
} WLE;

WLE *pWaitList=NULL;

/****************************************************************************
    FUNCTION: WaitForAsyncReturn
    PURPOSE:  wait for asyn function to complete
****************************************************************************/
int WaitForAsyncReturn(long *pRetCode)
{
MSG msg;
	if (*pRetCode>0)
	{
		WLE *pNewWLE;

		pNewWLE = malloc(sizeof(WLE));
		if (!pNewWLE)
			return -1;
		pNewWLE->pRetCode=pRetCode;
		pNewWLE->pNext=pWaitList;
		pWaitList=pNewWLE;

		/* spin on message loop until request id is reset */
	    while (GetMessage(&msg,
		    NULL,
		    NULL,
		    NULL))
	   	 {
			TranslateMessage(&msg);    //Translates virtual key codes
			DispatchMessage(&msg);     //Dispatches message to window
			if (*pRetCode <= 0)
				break;
	   	 } //End while (not a quit message)
	}
	return 0;
} /* end function (WaitForAsyncReturn) */
/****************************************************************************
    FUNCTION: AsyncReturn
    PURPOSE:  called to remove asyn function from list
****************************************************************************/
int AsyncReturn(long RequestID, long RetCode)
{
WLE *pFoundWLE, **ppPrevWLE;

	ppPrevWLE=&pWaitList;
	pFoundWLE=pWaitList;

	while (pFoundWLE)
	{
		if (*pFoundWLE->pRetCode==RequestID)
		{
			// update return code that application is spinning on
			*pFoundWLE->pRetCode=RetCode;

			// remove element from list
			*ppPrevWLE = pFoundWLE->pNext;

			// free memory associated with element
			free(pFoundWLE);

			// return success
			return 0;
		}
		ppPrevWLE=&pFoundWLE->pNext;
		pFoundWLE=pFoundWLE->pNext;
	}

	return -1;	// return failure- no element found
} /* end function (AsyncReturn) */

